﻿
#Область ОбработчикиСобытийФормы

&НаСервере
Процедура ПриСозданииНаСервере(Отказ, СтандартнаяОбработка)
	
	ЗаполнитьШаблоныУмолчаниями();
	
	ТекстИсключений = ЗагрузитьНастройку("ТекстИсключений");
	КаталогСФичами  = ЗагрузитьНастройку("КаталогСФичами");
	ВыбранныеИмена.ЗагрузитьЗначения(ЗагрузитьНастройку("ВыбранныеИмена", Новый Массив));
	
	ШаблонЗаголовокФайла = ЗагрузитьНастройку("ШаблонЗаголовокФайла", ШаблонЗаголовокФайла);
	ШаблонПодвалФайла = ЗагрузитьНастройку("ШаблонПодвалФайла", ШаблонПодвалФайла);
	ШаблоныПоТипам.Загрузить(ЗагрузитьНастройку("ШаблоныПоТипам", ШаблоныПоТипам.Выгрузить()));
	
	ДеревоМетаданныхЗаполнить();
	
КонецПроцедуры

&НаКлиенте
Процедура ПередЗакрытием(Отказ, ЗавершениеРаботы, ТекстПредупреждения, СтандартнаяОбработка)
	
	ПередЗакрытиемНаСервере();
	
КонецПроцедуры

#КонецОбласти

#Область ОбработчикиСобытийЭлементовШапкиФормы

&НаКлиенте
Процедура КаталогСФичамиНачалоВыбора(Элемент, ДанныеВыбора, СтандартнаяОбработка)
	
	СтандартнаяОбработка = Ложь;
	
	ДиалогВыбораКаталога = Новый ДиалогВыбораФайла(РежимДиалогаВыбораФайла.ВыборКаталога);
	ДиалогВыбораКаталога.ПолноеИмяФайла = КаталогСФичами;
	ДиалогВыбораКаталога.МножественныйВыбор = Ложь;
	
	КаталогСФичамиНачалоВыбораЗавершение = Новый ОписаниеОповещения("КаталогСФичамиНачалоВыбораЗавершение", ЭтотОбъект);
	
	ДиалогВыбораКаталога.Показать(КаталогСФичамиНачалоВыбораЗавершение);
	
КонецПроцедуры

#КонецОбласти

#Область ОбработчикиКомандФормы

&НаКлиенте
Процедура СделатьВсе(Команда)
	
	ДеревоОбъектовМетаданных.ПолучитьЭлементы().Очистить();
	ВыбранныеИмена.Очистить();
	
	Состояние("Создание фиче-файлов", 25, "Заполнение дерева");
	ДеревоМетаданныхЗаполнить();
	кореньДерева = ДеревоОбъектовМетаданных.ПолучитьЭлементы()[0];
	кореньДерева.Пометка = 1;
	ПриПометкеЭлементаДерева(кореньДерева, "Пометка");
	
	Состояние("Создание фиче-файлов", 50, "Исключение исключений");
	ЗаполнитьСУчетомИсключений(Команда);
	
	Состояние("Создание фиче-файлов", 75, "Генерация сценария");
	СформироватьСценарии(Команда);
	
	Состояние("Создание фиче-файлов", 90, "Сохранение в файлы");
	ЗаписатьФайлы(Команда);
	
	Состояние("Создание фиче-файлов", 100, "Открытие каталога");
	
КонецПроцедуры

&НаКлиенте
Процедура ЗаполнитьСУчетомИсключений(Команда)
	
	ЗаполнитьСУчетомИсключенийНаСервере();
	
КонецПроцедуры

&НаКлиенте
Процедура СформироватьСценарии(Команда)
	
	СформироватьСценарииПоДереву();
	
КонецПроцедуры

&НаКлиенте
Процедура ВыгрузитьНастройки(Команда)
	
	Диалог = Новый ДиалогВыбораФайла(РежимДиалогаВыбораФайла.Сохранение);
	Диалог.Заголовок               = "Сохранение настроек генератора Дымовых тестов для открытия форм";
	Диалог.ПредварительныйПросмотр = Ложь;
	Диалог.МножественныйВыбор      = Ложь;
	Диалог.Фильтр                  = "Настройки (*.json)|*.json";
	Диалог.ПолноеИмяФайла          = "SmokeParams_OpenForms";
	Диалог.Расширение              = "json";
	
	ОписаниеОповещения = Новый ОписаниеОповещения("ВыгрузитьНастройкиЗавершение", ЭтотОбъект);
	Диалог.Показать(ОписаниеОповещения);
	
КонецПроцедуры

&НаКлиенте
Процедура ЗагрузитьНастройки(Команда)
	
	Диалог = Новый ДиалогВыбораФайла(РежимДиалогаВыбораФайла.Открытие);
	Диалог.МножественныйВыбор = Ложь;
	Диалог.Заголовок          = "Выберите файл настроек генератора Дымовых тестов для открытия форм.";
	Диалог.Фильтр             = "Настройки (*.json)|*.json";
	ОписаниеОповещения        = Новый ОписаниеОповещения("ЗагрузитьНастройкиОбработчикОповещения", ЭтотОбъект);
	Диалог.Показать(ОписаниеОповещения);
	
КонецПроцедуры

&НаКлиенте
Процедура СброситьШаблоны(Команда)
	
	ЗаполнитьШаблоныУмолчаниями();
	
КонецПроцедуры

&НаКлиенте
Процедура ЗаписатьФайлы(Команда)
	
	Если Не ЗначениеЗаполнено(КаталогСФичами) Тогда
		
		сообщение = Новый СообщениеПользователю;
		сообщение.Поле = "КаталогСФичами";
		сообщение.Текст = "Не указан каталог для сохранения";
		
		сообщение.Сообщить();
		
	КонецЕсли;
	
	Если Не ЗначениеЗаполнено(СгенерированныйСценарий) Тогда
		
		СформироватьСценарииПоДереву();
		
	КонецЕсли;
	
	текСценарий = "";
	текИмя = "";
	установитьИмя = Ложь;
	записатьСценарий = Ложь;
	
	Для каждого строкаСценария Из СтрРазделить(СгенерированныйСценарий, Символы.ПС) Цикл
		
		Если строкаСценария = РазделительФичеФайлов() Тогда
			
			Если записатьСценарий Тогда
				
				ЗТ = Новый ЗаписьТекста(текИмя, КодировкаТекста.UTF8, , Ложь); 
				ЗТ.ЗаписатьСтроку(СокрЛП(текСценарий));
				ЗТ.Закрыть();
				
			КонецЕсли;
			
			текИмя = "";
			установитьИмя = Истина;
			записатьСценарий = Истина;
			Продолжить;
			
		КонецЕсли;
		
		Если установитьИмя Тогда
			
			текИмя = КаталогСФичами + "\" + строкаСценария;
			текСценарий = "";
			установитьИмя = Ложь;
			Продолжить;
			
		КонецЕсли;
		
		текСценарий = текСценарий + Символы.ПС + строкаСценария;
		
	КонецЦикла;
	
	Если ЗначениеЗаполнено(текСценарий)
		И ЗначениеЗаполнено(текИмя) Тогда
		
		ЗТ = Новый ЗаписьТекста(текИмя, КодировкаТекста.UTF8, , Ложь); 
		ЗТ.ЗаписатьСтроку(СокрЛП(текСценарий));
		ЗТ.Закрыть();
		
	КонецЕсли;
	
	ОткрытьКаталогСФичами();
	
КонецПроцедуры

#КонецОбласти

#Область ОбработчикиСобытийЭлементовТаблицыФормыОбработчикиСобытийЭлементовТаблицыФормы

&НаКлиенте
Процедура ДеревоОбъектовМетаданныхФлажокПриИзменении(Элемент)
	
	ЭлементДерева = ТекущийЭлемент.ТекущиеДанные;
	ПриПометкеЭлементаДерева(ЭлементДерева, "Пометка");
	
КонецПроцедуры

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

&НаКлиенте
Процедура ОткрытьКаталогСФичами()
	
	Если Не ЗначениеЗаполнено(КаталогСФичами) Тогда
		
		сообщение = Новый СообщениеПользователю;
		сообщение.Поле = "КаталогСФичами";
		сообщение.Текст = "Не указан каталог для сохранения";
		
		сообщение.Сообщить();
		
		Возврат;
		
	КонецЕсли;
	
	Оповещение = Новый ОписаниеОповещения(, , , "ОткрытьПроводникПриОбработкеОшибки", ЭтотОбъект);
	
	НачатьЗапускПриложения(Оповещение, "file:///" + КаталогСФичами);
	
КонецПроцедуры

&НаКлиенте
Процедура ОткрытьПроводникПриОбработкеОшибки(ИнформацияОбОшибке, СтандартнаяОбработка, Контекст) Экспорт
	
	СтандартнаяОбработка = Ложь;
	
	Если Не ПустаяСтрока(Контекст) Тогда
		
		ПоказатьПредупреждение(, Контекст);
		
	КонецЕсли;
	
КонецПроцедуры

&НаКлиенте
Процедура КаталогСФичамиНачалоВыбораЗавершение(ВыбранныеФайлы, ТекущиеДанные) Экспорт
	
	Если ВыбранныеФайлы = Неопределено
		Или ВыбранныеФайлы.Количество() = 0 Тогда
		
		Возврат;
	КонецЕсли;
	
	КаталогСФичами = ВыбранныеФайлы[0];
	
КонецПроцедуры

#Область ДеревоМетаданных

// Добавляет новую строку в дерево значений формы (дерево),
// а также заполняет полный набор строк из метаданных по переданному параметру.
//
// Если параметр Подсистемы заполнен, то вызывается рекурсивно для всех дочерних подсистем.
//
// Параметры:
//   ПараметрыЭлемента - Структура с полями:
//     Имя           - Строка - имя родительского элемента.
//     Синоним       - Строка - синоним родительского элемента.
//     Пометка       - Булево - начальная пометка коллекции или объекта метаданных.
//     Картинка      - Число - код картинки родительского элемента.
//     КартинкаОбъекта - Число - код картинки подэлемента.
//     Родитель        - ссылка на элемента дерева значений, который является корнем
//                       для добавляемого элемента.
//   Подсистемы      - если заполнен, то содержит значение Метаданные.Подсистемы (коллекцию элементов).
//   Проверять       - Булево - признак проверки на принадлежность родительским подсистемам.
//
// Возвращаемое значение:
//
//   Строка дерева объектов метаданных.
//
&НаСервере
Функция ДобавитьЭлементДереваОбъектовМетаданных(ПараметрыЭлемента, Проверять = Истина)
	
	Если Метаданные[ПараметрыЭлемента.Имя].Количество() = 0 Тогда
		
		Возврат Неопределено;
	
	КонецЕсли;
	
	НоваяСтрока = НоваяСтрокаДерева(ПараметрыЭлемента, Ложь);
	
	Для Каждого ЭлементКоллекцииМетаданных Из Метаданные[ПараметрыЭлемента.Имя] Цикл
		
		ПараметрыЭлемента = ПараметрыЭлементаДереваОбъектовМетаданных();
		ПараметрыЭлемента.Имя             = ЭлементКоллекцииМетаданных.Имя;
		ПараметрыЭлемента.ПолноеИмя       = ЭлементКоллекцииМетаданных.ПолноеИмя();
		ПараметрыЭлемента.Синоним         = ЭлементКоллекцииМетаданных.Синоним;
		ПараметрыЭлемента.КартинкаОбъекта = ПараметрыЭлемента.КартинкаОбъекта;
		ПараметрыЭлемента.Родитель        = НоваяСтрока;
		ПараметрыЭлемента.Тип             = ТипОбъектаМетаданных(ЭлементКоллекцииМетаданных);
		НоваяСтрокаДерева(ПараметрыЭлемента, Истина);
		
	КонецЦикла;
	
	Возврат НоваяСтрока;
	
КонецФункции

// Добавляет новую строку в таблицу значений видов объектов метаданных
// конфигурации.
//
// Параметры:
// Имя           - имя объекта метаданных или вида объекта метаданных.
// Синоним       - синоним объекта метаданных.
// Картинка      - картинка поставленная в соответствие объекту метаданных
//                 или виду объекта метаданных.
// ЭтоКоллекцияОбщие - признак того, что текущий элемент содержит подэлементы.
//
&НаСервере
Процедура КоллекцииОбъектовМетаданных_НоваяСтрока(Имя, Синоним, Картинка, КартинкаОбъекта, Таб)
	
	НоваяСтрока = Таб.Добавить();
	НоваяСтрока.Имя             = Имя;
	НоваяСтрока.Синоним         = Синоним;
	НоваяСтрока.Картинка        = Картинка;
	НоваяСтрока.КартинкаОбъекта = КартинкаОбъекта;
	
КонецПроцедуры

// Возвращает новую структуру параметров элемента дерева объектов метаданных.
//
// Возвращаемое значение:
//   Структура с полями:
//     Имя           - Строка - имя родительского элемента.
//     Синоним       - Строка - синоним родительского элемента.
//     Пометка       - Булево - начальная пометка коллекции или объекта метаданных.
//     Картинка      - Число - код картинки родительского элемента.
//     КартинкаОбъекта - Число - код картинки подэлемента.
//     Родитель        - ссылка на элемента дерева значений, который является корнем
//                       для добавляемого элемента.
//
&НаСервере
Функция ПараметрыЭлементаДереваОбъектовМетаданных()
	
	СтруктураПараметров = Новый Структура;
	СтруктураПараметров.Вставить("Имя", "");
	СтруктураПараметров.Вставить("ПолноеИмя", "");
	СтруктураПараметров.Вставить("Синоним", "");
	СтруктураПараметров.Вставить("Пометка", 0);
	СтруктураПараметров.Вставить("Картинка", 0);
	СтруктураПараметров.Вставить("КартинкаОбъекта", Неопределено);
	СтруктураПараметров.Вставить("Родитель", Неопределено);
	СтруктураПараметров.Вставить("Тип", "");
	
	Возврат СтруктураПараметров;
	
КонецФункции

&НаСервере
Функция НоваяСтрокаДерева(ПараметрыСтроки, ЭтоОбъектМетаданных = Ложь)
	
	Если ЭтоОбъектМетаданных
		И Не ЕстьФормы(ПараметрыСтроки) Тогда

		Возврат Неопределено;
		
	КонецЕсли;
	
	Коллекция = ПараметрыСтроки.Родитель.ПолучитьЭлементы();
	НоваяСтрока                     = Коллекция.Добавить();
	НоваяСтрока.Имя                 = ПараметрыСтроки.Имя;
	НоваяСтрока.Представление       = ?(ЗначениеЗаполнено(ПараметрыСтроки.Синоним), ПараметрыСтроки.Синоним, ПараметрыСтроки.Имя);
	НоваяСтрока.Картинка            = ПараметрыСтроки.Картинка;
	НоваяСтрока.ПолноеИмя           = ПараметрыСтроки.ПолноеИмя;
	НоваяСтрока.ЭтоОбъектМетаданных = ЭтоОбъектМетаданных;
	НоваяСтрока.Тип                 = ПараметрыСтроки.Тип;
	
	Возврат НоваяСтрока;
	
КонецФункции

&НаСервере
Функция ЕстьФормы(Знач ПараметрыСтроки)
	
	мета = Метаданные.НайтиПоПолномуИмени(ПараметрыСтроки.ПолноеИмя);
	
	Если ПараметрыСтроки.Тип = "Справочник"
		ИЛИ ПараметрыСтроки.Тип = "Документ"
		ИЛИ ПараметрыСтроки.Тип = "ПланВидовХарактеристик"
		ИЛИ ПараметрыСтроки.Тип = "ПланСчетов" Тогда
		
		Возврат Не мета.ОсновнаяФормаОбъекта = Неопределено ИЛИ Не мета.ОсновнаяФормаСписка = Неопределено;
		
	ИначеЕсли ПараметрыСтроки.Тип = "ЖурналДокументов"
		ИЛИ ПараметрыСтроки.Тип = "Обработка" Тогда
		
		Возврат Не мета.ОсновнаяФорма = Неопределено;
		
	ИначеЕсли ПараметрыСтроки.Тип = "Отчет" Тогда
		
		Возврат Истина;
		
	ИначеЕсли ПараметрыСтроки.Тип = "РегистрСведений" Тогда
		
		Возврат Не мета.ОсновнаяФормаСписка = Неопределено ИЛИ Не мета.ОсновнаяФормаЗаписи = Неопределено;
		
	ИначеЕсли ПараметрыСтроки.Тип = "РегистрНакопления"
		ИЛИ ПараметрыСтроки.Тип = "РегистрБухгалтерии" Тогда
		
		Возврат Не мета.ОсновнаяФормаСписка = Неопределено;
		
	Иначе
		
		ВызватьИсключение "Неподдерживаемый тип метаданных. Поддержите его, пожалуйста.";
		
	КонецЕсли;
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Функция ВсеСтрокиДерева(ДеревоОбъектовМетаданных, ТолькоОтмеченные = Ложь)

	строкиДерева = Новый Массив;
	
	Для каждого цСтрокаКорня Из ДеревоОбъектовМетаданных.ПолучитьЭлементы() Цикл
		
		Для каждого цСтрокаМета Из цСтрокаКорня.ПолучитьЭлементы() Цикл
			
			Для каждого цСтрокаДерева Из цСтрокаМета.ПолучитьЭлементы() Цикл
				
				Если Не ТолькоОтмеченные
					ИЛИ цСтрокаДерева.Пометка = 1 Тогда
					
					строкиДерева.Добавить(цСтрокаДерева);
					
				КонецЕсли;
				
			КонецЦикла;
			
		КонецЦикла;
		
	КонецЦикла;

	Возврат строкиДерева;
	
КонецФункции

&НаСервере
Процедура ЗаполнитьДеревоПоСпискуИмен()
	
	соотИмена = Новый Соответствие;
	
	Для каждого цЭлемент Из ВыбранныеИмена Цикл
		
		соотИмена.Вставить(цЭлемент.Значение, 1);
		
	КонецЦикла;
	
	Для каждого цСтрокаДерева Из ВсеСтрокиДерева(ДеревоОбъектовМетаданных) Цикл
		
		цСтрокаДерева.Пометка = соотИмена[цСтрокаДерева.ПолноеИмя];
		
	КонецЦикла;
	
	ОбновитьПометкиВДереве();

КонецПроцедуры

&НаСервере
Процедура ОбновитьПометкиВДереве()
	
	Для каждого цСтрокаКорня Из ДеревоОбъектовМетаданных.ПолучитьЭлементы() Цикл
		
		Для каждого цСтрокаМета Из цСтрокаКорня.ПолучитьЭлементы() Цикл
			
			Для каждого цСтрокаДерева Из цСтрокаМета.ПолучитьЭлементы() Цикл
				
				ПриПометкеЭлементаДерева(цСтрокаДерева, "Пометка");
				Прервать;
				
			КонецЦикла;
			
		КонецЦикла;
		
	КонецЦикла;

КонецПроцедуры

&НаСервере
Процедура ЗаполнитьВыбранныеИмена()
	
	ВыбранныеИмена.Очистить();
	
	Для каждого цСтрокаДерева Из ВсеСтрокиДерева(ДеревоОбъектовМетаданных, Истина) Цикл
		
		ВыбранныеИмена.Добавить(цСтрокаДерева.ПолноеИмя);
		
	КонецЦикла;
	
КонецПроцедуры

&НаКлиенте
Процедура СформироватьСценарииПоДереву()
	
	МассивСценариев = МассивСценариев();
	
	СформироватьТекстыСценариев(МассивСценариев);
	
	Элементы.ГруппаСтраницы.ТекущаяСтраница = Элементы.СтраницаСценарийПоведения;
	
КонецПроцедуры

&НаСервере
Процедура ДеревоМетаданныхЗаполнить()
	
	КоллекцииОбъектовМетаданных = Новый ТаблицаЗначений;
	КоллекцииОбъектовМетаданных.Колонки.Добавить("Имя");
	КоллекцииОбъектовМетаданных.Колонки.Добавить("Синоним");
	КоллекцииОбъектовМетаданных.Колонки.Добавить("Картинка");
	КоллекцииОбъектовМетаданных.Колонки.Добавить("КартинкаОбъекта");
	КоллекцииОбъектовМетаданных.Колонки.Добавить("ПолноеИмя");
	КоллекцииОбъектовМетаданных.Колонки.Добавить("Родитель");
	КоллекцииОбъектовМетаданных.Колонки.Добавить("Тип");
	
	КоллекцииОбъектовМетаданных_НоваяСтрока("Справочники",
											"Справочники",
											БиблиотекаКартинок.Справочник,
											БиблиотекаКартинок.Справочник,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("Документы",
											"Документы",
											БиблиотекаКартинок.Документ,
											БиблиотекаКартинок.ДокументОбъект,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("ЖурналыДокументов",
											"ЖурналыДокументов",
											БиблиотекаКартинок.ЖурналДокументов,
											БиблиотекаКартинок.ЖурналДокументов,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("Отчеты",
											"Отчеты",
											БиблиотекаКартинок.Отчет,
											БиблиотекаКартинок.Отчет,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("Обработки",
											"Обработки",
											БиблиотекаКартинок.Обработка,
											БиблиотекаКартинок.Обработка,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("ПланыВидовХарактеристик",
											"ПланыВидовХарактеристик",
											БиблиотекаКартинок.ПланВидовХарактеристик,
											БиблиотекаКартинок.ПланВидовХарактеристик,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("ПланыСчетов",
											"ПланыСчетов",
											БиблиотекаКартинок.ПланСчетов,
											БиблиотекаКартинок.ПланСчетов,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("РегистрыСведений",
											"Регистры сведений",
											БиблиотекаКартинок.РегистрСведений,
											БиблиотекаКартинок.РегистрСведений,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("РегистрыНакопления",
											"Регистры накопления",
											БиблиотекаКартинок.РегистрНакопления,
											БиблиотекаКартинок.РегистрНакопления,
											КоллекцииОбъектовМетаданных);
	КоллекцииОбъектовМетаданных_НоваяСтрока("РегистрыБухгалтерии",
											"Регистры бухгалтерии",
											БиблиотекаКартинок.РегистрБухгалтерии,
											БиблиотекаКартинок.РегистрБухгалтерии,
											КоллекцииОбъектовМетаданных);
	
	// Создание предопределенных элементов.
	ПараметрыЭлемента = ПараметрыЭлементаДереваОбъектовМетаданных();
	ПараметрыЭлемента.Имя      = Метаданные.Имя;
	ПараметрыЭлемента.Синоним  = Метаданные.Синоним;
	ПараметрыЭлемента.Картинка = 79;
	ПараметрыЭлемента.Родитель = ДеревоОбъектовМетаданных;
	ЭлементКонфигурация        = НоваяСтрокаДерева(ПараметрыЭлемента);
	
	// Заполнение дерева объектов метаданных.
	Для Каждого Строка Из КоллекцииОбъектовМетаданных Цикл
		
		Строка.Родитель = ЭлементКонфигурация;
		ДобавитьЭлементДереваОбъектовМетаданных(Строка);
		
	КонецЦикла;
	
	Если ВыбранныеИмена.Количество() > 0 Тогда
		
		ЗаполнитьДеревоПоСпискуИмен();
		
	КонецЕсли;
	
КонецПроцедуры

&НаКлиентеНаСервереБезКонтекста
Процедура ПометитьОсновнойЭлемент(ЭлементДерева, ТекущаяКолонка)
	
	Если ЭлементДерева.Пометка <> ЭлементДерева[ТекущаяКолонка] Тогда
		
		ЭлементДерева.Пометка = ЭлементДерева[ТекущаяКолонка];
		ПриПометкеЭлементаДерева(ЭлементДерева, "Пометка");
		
	КонецЕсли;
	
КонецПроцедуры

&НаКлиентеНаСервереБезКонтекста
Процедура ПриПометкеЭлементаДерева(ЭлементДерева, ИмяКолонки)
	
	ЭлементДерева[ИмяКолонки] = СледующееЗначениеПометкиЭлемента(ЭлементДерева, ИмяКолонки);
	
	Если ТребуетсяПометитьВложенныеЭлементы(ЭлементДерева, ИмяКолонки) Тогда
		
		ПометитьВложенныеЭлементыРекурсивно(ЭлементДерева, ИмяКолонки);
		
	КонецЕсли;
	
	Если ЭлементДерева[ИмяКолонки] = ПометкаФлажокНеУстановлен() Тогда
		
		ЭлементДерева[ИмяКолонки] = ЗначениеПометкиОтносительноВложенныхЭлементов(ЭлементДерева, ИмяКолонки);
		
	КонецЕсли;
	
	ПометитьЭлементыРодителейРекурсивно(ЭлементДерева, ИмяКолонки);
	
	ПометитьОсновнойЭлемент(ЭлементДерева, ИмяКолонки);
	
КонецПроцедуры

&НаКлиентеНаСервереБезКонтекста
Функция СледующееЗначениеПометкиЭлемента(ЭлементДерева, ИмяКолонки)
	
	Если ЭлементДерева.ЭтоОбъектМетаданных Тогда
		
		// Предыдущее значение пометки = 2 : Установлен квадрат.
		Если ЭлементДерева[ИмяКолонки] = 0 Тогда
			
			Возврат ПометкаФлажокНеУстановлен();
		
		КонецЕсли;
	
	КонецЕсли;
	
	// Предыдущее значение пометки = 1 : Флажок установлен.
	Если ЭлементДерева[ИмяКолонки] = 2 Тогда
		
		Возврат ПометкаФлажокНеУстановлен();
	
	КонецЕсли;
	
	Возврат ЭлементДерева[ИмяКолонки];
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Функция ТребуетсяПометитьВложенныеЭлементы(ЭлементДерева, ИмяКолонки)
	
	Если ЭлементДерева.ЭтоОбъектМетаданных Тогда
		
		СостояниеВложенныхЭлементов = СостояниеВложенныхЭлементов(ЭлементДерева, ИмяКолонки);
		
		ЕстьПомеченные   = СостояниеВложенныхЭлементов.ЕстьПомеченные;
		ЕстьНепомеченные = СостояниеВложенныхЭлементов.ЕстьНепомеченные;
		
		Если ЕстьПомеченные И ЕстьНепомеченные Тогда
			
			Возврат Ложь;
		
		КонецЕсли;
	
	КонецЕсли;
	
	Возврат Истина;
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Процедура ПометитьЭлементыРодителейРекурсивно(ЭлементДерева, ИмяКолонки)
	
	Родитель = ЭлементДерева.ПолучитьРодителя();
	
	Если Родитель = Неопределено Тогда
		
		Возврат;
	
	КонецЕсли;
	
	ЭлементыРодителя = Родитель.ПолучитьЭлементы();
	
	Если ЭлементыРодителя.Количество() = 0 Тогда
		
		Родитель[ИмяКолонки] = ПометкаФлажокУстановлен();
		
	ИначеЕсли ЭлементДерева.Пометка = ПометкаКвадрат() Тогда
		
		Родитель[ИмяКолонки] = ПометкаКвадрат();
		
	Иначе
		
		Родитель[ИмяКолонки] = ЗначениеПометкиОтносительноВложенныхЭлементов(Родитель, ИмяКолонки);
		
	КонецЕсли;
	
	ПометитьЭлементыРодителейРекурсивно(Родитель, ИмяКолонки);
	
КонецПроцедуры

&НаКлиентеНаСервереБезКонтекста
Функция ЗначениеПометкиОтносительноВложенныхЭлементов(ЭлементДерева, ИмяКолонки)
	
	СостояниеВложенныхЭлементов = СостояниеВложенныхЭлементов(ЭлементДерева, ИмяКолонки);
	
	ЕстьПомеченные   = СостояниеВложенныхЭлементов.ЕстьПомеченные;
	ЕстьНепомеченные = СостояниеВложенныхЭлементов.ЕстьНепомеченные;
	
	Если ЭлементДерева.ЭтоОбъектМетаданных Тогда
		
		Если ЭлементДерева[ИмяКолонки] = ПометкаФлажокУстановлен() Тогда
			
			// Оставляем флажок взведенным независимо от вложенных.
			Возврат ПометкаФлажокУстановлен();
		
		КонецЕсли;
		
		Если ЭлементДерева[ИмяКолонки] = ПометкаФлажокНеУстановлен()
			Или ЭлементДерева[ИмяКолонки] = ПометкаКвадрат() Тогда
			
			Если ЕстьПомеченные Тогда
				
				Возврат ПометкаКвадрат();
			
			Иначе
				
				Возврат ПометкаФлажокНеУстановлен();
			
			КонецЕсли;
		
		КонецЕсли;
		
	Иначе
		
		Если ЕстьПомеченные Тогда
			
			Если ЕстьНепомеченные Тогда
				
				Возврат ПометкаКвадрат();
			
			Иначе
				
				Возврат ПометкаФлажокУстановлен();
			
			КонецЕсли;
			
		КонецЕсли;
		
		Возврат ПометкаФлажокНеУстановлен();
		
	КонецЕсли;
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Функция СостояниеВложенныхЭлементов(ЭлементДерева, ИмяКолонки)
	
	ВложенныеЭлементы = ЭлементДерева.ПолучитьЭлементы();
	
	ЕстьПомеченные   = Ложь;
	ЕстьНепомеченные = Ложь;
	
	Для каждого ВложенныйЭлемент Из ВложенныеЭлементы Цикл
		
		Если ВложенныйЭлемент[ИмяКолонки] = ПометкаФлажокНеУстановлен() Тогда
			
			ЕстьНепомеченные = Истина;
			Продолжить;
			
		КонецЕсли;
		
		Если ВложенныйЭлемент[ИмяКолонки] = ПометкаФлажокУстановлен() Тогда
			
			ЕстьПомеченные = Истина;
			
			Если ВложенныйЭлемент.ЭтоОбъектМетаданных Тогда
				
				Состояние        = СостояниеВложенныхЭлементов(ВложенныйЭлемент, ИмяКолонки);
				ЕстьПомеченные   = ЕстьПомеченные Или Состояние.ЕстьПомеченные;
				ЕстьНепомеченные = ЕстьНепомеченные Или Состояние.ЕстьНепомеченные;
				
			КонецЕсли;
			
			Продолжить;
			
		КонецЕсли;
		
		Если ВложенныйЭлемент[ИмяКолонки] = ПометкаКвадрат() Тогда
			
			ЕстьПомеченные   = Истина;
			ЕстьНепомеченные = Истина;
			Продолжить;
			
		КонецЕсли;
		
	КонецЦикла;
	
	Результат = Новый Структура;
	Результат.Вставить("ЕстьПомеченные", ЕстьПомеченные);
	Результат.Вставить("ЕстьНепомеченные", ЕстьНепомеченные);
	
	Возврат Результат;
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Процедура ПометитьВложенныеЭлементыРекурсивно(ЭлементДерева, ИмяКолонки)
	
	ВложенныеЭлементы = ЭлементДерева.ПолучитьЭлементы();
	
	Для каждого ВложенныйЭлемент Из ВложенныеЭлементы Цикл
		
		ВложенныйЭлемент[ИмяКолонки] = ЭлементДерева[ИмяКолонки];
		ПометитьВложенныеЭлементыРекурсивно(ВложенныйЭлемент, ИмяКолонки);
		
	КонецЦикла;
	
КонецПроцедуры

&НаКлиентеНаСервереБезКонтекста
Функция ПометкаФлажокНеУстановлен()
	
	Возврат 0;
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Функция ПометкаФлажокУстановлен()
	
	Возврат 1;
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Функция ПометкаКвадрат()
	
	Возврат 2;
	
КонецФункции

&НаСервере
Функция ТипОбъектаМетаданных(ОбъектМетаданных)
	
	Если Метаданные.Справочники.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "Справочник";
		
	ИначеЕсли Метаданные.Документы.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "Документ";
		
	ИначеЕсли Метаданные.ЖурналыДокументов.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "ЖурналДокументов";
		
	ИначеЕсли Метаданные.Обработки.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "Обработка";
		
	ИначеЕсли Метаданные.Отчеты.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "Отчет";
		
	ИначеЕсли Метаданные.БизнесПроцессы.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "БизнесПроцесс";
		
	ИначеЕсли Метаданные.ПланыВидовХарактеристик.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "ПланВидовХарактеристик";
		
	ИначеЕсли Метаданные.ПланыСчетов.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "ПланСчетов";
		
	ИначеЕсли Метаданные.ПланыВидовРасчета.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "ПланВидовРасчета";
		
	ИначеЕсли Метаданные.Задачи.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "Задача";
		
	ИначеЕсли Метаданные.ПланыОбмена.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "ПланОбмена";
		
	ИначеЕсли Метаданные.РегистрыСведений.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "РегистрСведений";
		
	ИначеЕсли Метаданные.РегистрыНакопления.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "РегистрНакопления";
		
	ИначеЕсли Метаданные.РегистрыБухгалтерии.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "РегистрБухгалтерии";
		
	ИначеЕсли Метаданные.РегистрыРасчета.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "РегистрРасчета";
		
	ИначеЕсли Метаданные.Перечисления.Содержит(ОбъектМетаданных) Тогда
		
		Возврат "Перечисление";
		
	Иначе
		
		ТекстСообщения = "Неверный тип значения параметра (%1)";
		ТекстСообщения = СтрЗаменить(ТекстСообщения, "%1", Строка(ОбъектМетаданных));
		ВызватьИсключение ТекстСообщения;
		
	КонецЕсли;
	
КонецФункции

#КонецОбласти

#Область Исключения

&НаСервере
Процедура ЗаполнитьСУчетомИсключенийНаСервере()
	
	исключения = Новый Массив;
	
	Для каждого цИсключение Из СтрРазделить(ТекстИсключений, Символы.ПС, Ложь) Цикл
		
		исключения.Добавить(ПодготовитьШаблонКИспользованиюВРегулярке(цИсключение));
		
	КонецЦикла;
	
	регулярка = Неопределено;
	
	Для каждого цСтрокаДерева Из ВсеСтрокиДерева(ДеревоОбъектовМетаданных, Истина) Цикл
		
		Для каждого цИсключение Из исключения Цикл
			
			Если СтрокаСоответствуетШаблону(цСтрокаДерева.ПолноеИмя, цИсключение, регулярка) Тогда
				
				цСтрокаДерева.Пометка = 0;
				Прервать;
				
			КонецЕсли;
			
		КонецЦикла;
		
	КонецЦикла;
	
	ОбновитьПометкиВДереве();
	
КонецПроцедуры

#КонецОбласти

#Область ГенерацияСценариев

&НаСервере
Процедура СформироватьТекстыСценариев(МассивСценариев)
	
	текстыПоТипам = Новый Структура;
	
	Для Каждого СтрокаСценария Из МассивСценариев Цикл
		
		Если текстыПоТипам.Свойство(СтрокаСценария.Тип) Тогда
			
			ТекстовыйДокумент = текстыПоТипам[СтрокаСценария.Тип];
			
		Иначе
			
			заголовокФайла = ШаблонЗаголовокФайла;
			
			заголовокФайла = СтрЗаменить(заголовокФайла, "%ТипОбъекта%", СтрокаСценария.Тип);
			
			ТекстовыйДокумент = Новый ТекстовыйДокумент();
			ТекстовыйДокумент.ДобавитьСтроку(заголовокФайла);
			ТекстовыйДокумент.ДобавитьСтроку("");
			
			текстыПоТипам.Вставить(СтрокаСценария.Тип, ТекстовыйДокумент);
			
		КонецЕсли;
		
		ТекстСценария = ШаблонСценарияОткрытьФорму(СтрокаСценария);
		
		ТекстовыйДокумент.ДобавитьСтроку("");
		ТекстовыйДокумент.ДобавитьСтроку(ТекстСценария);
		
	КонецЦикла;
	
	СгенерированныйСценарий = "";
	
	Для каждого цКлючИЗначение Из текстыПоТипам Цикл
		
		подвалФайла = ШаблонПодвалФайла;
		
		подвалФайла = СтрЗаменить(подвалФайла, "%ТипОбъекта%", цКлючИЗначение.Ключ);
		
		СгенерированныйСценарий = СгенерированныйСценарий + "
		|
		|" + РазделительФичеФайлов() + "
		|" + цКлючИЗначение.Ключ + ".feature
		|
		|" + цКлючИЗначение.Значение.ПолучитьТекст() + "
		|
		|" + подвалФайла;
		
	КонецЦикла;
	
КонецПроцедуры

&НаКлиентеНаСервереБезКонтекста
Функция РазделительФичеФайлов()

	Возврат "=== Начало фиче-файла ===";

КонецФункции

&НаКлиенте
Функция МассивСценариев()
	
	МассивСценариев = Новый Массив;
	
	Для каждого цСтрокаДерева Из ВсеСтрокиДерева(ДеревоОбъектовМетаданных, Истина) Цикл
		
		СтруктураСценария = СтруктураСценария();
		
		ЗаполнитьЗначенияСвойств(СтруктураСценария, цСтрокаДерева);
		МассивСценариев.Добавить(СтруктураСценария);
		
	КонецЦикла;
	
	Возврат МассивСценариев;
	
КонецФункции

&НаКлиенте
Функция СтруктураСценария()
	
	СтруктураСценария = Новый Структура;
	СтруктураСценария.Вставить("Имя", "");
	СтруктураСценария.Вставить("ПолноеИмя", "");
	СтруктураСценария.Вставить("СценарийОткрытьФорму", Ложь);
	СтруктураСценария.Вставить("СценарийЗаписьНового", Ложь);
	СтруктураСценария.Вставить("СценарийЗаписьСуществующего", Ложь);
	СтруктураСценария.Вставить("СценарийВводНаОсновании", Ложь);
	СтруктураСценария.Вставить("Тип", "");
	
	Возврат СтруктураСценария;
	
КонецФункции

#Область ШаблоныСценариев

&НаСервере
Процедура ЗаполнитьШаблоныУмолчаниями()
	
	ШаблонЗаголовокФайла = "#language: ru
	|
	|@tree
	|
	|Функциональность: %ТипОбъекта%. Дымовые тесты
	|
	|Сценарий: %ТипОбъекта%. Инициализация
	|
	|	Дано Я подключаюсь под ""Администратор""
	|	Дано Я отключаю все регламентные задания
	|	Дано Я устанавливаю время начала блока тестов
	|	Дано Я включаю все функциональные опции
	|	Дано Я устанавливаю заголовок ""%ТипОбъекта%. Дым""
	|	Дано я устанавливаю текущему сеансу заголовок приложения ""%ТипОбъекта%. Дым""";
	
	ШаблонПодвалФайла = "Сценарий: %ТипОбъекта%. Обработка Журнал регистрации
	|
	|	Дано В журнале регистрации ""0"" ошибок по текущему блоку";
	
	ШаблоныПоТипам.Очистить();
	
	Для каждого цТип Из СтрРазделить("Справочник,Документ,ПланВидовХарактеристик,ПланСчетов,РегистрСведений,РегистрНакопления,РегистрБухгалтерии", ",") Цикл
		
		новСтрока = ШаблоныПоТипам.Добавить();
		
		новСтрока.Тип = цТип;
		новСтрока.Шаблон = "Сценарий: Открытие формы списка %ТипОбъекта% ""%Имя%""
		|
		|	Дано Я открываю навигационную ссылку ""e1cib/list/%ПолноеИмя%""
		|	Если появилось предупреждение тогда
		|		Тогда я закрыл все окна клиентского приложения
		|		Тогда я вызываю исключение ""Не удалось открыть форму списка %ТипОбъекта% %Имя%""
		|	И Я закрываю текущее окно
		|
		|Сценарий: Открытие формы объекта %ТипОбъекта% ""%Имя%""
		|
		|	Дано Я открываю навигационную ссылку ""e1cib/data/%ПолноеИмя%""
		|	Если появилось предупреждение тогда
		|		Тогда я закрыл все окна клиентского приложения
		|		Тогда я вызываю исключение ""Не удалось открыть форму объекта %ТипОбъекта% %Имя%""
		|	И Я закрываю текущее окно";
		
	КонецЦикла;
	
	новСтрока = ШаблоныПоТипам.Добавить();
	
	новСтрока.Тип = "ЖурналДокументов";
	новСтрока.Шаблон = "Сценарий: Открытие формы журнала документов ""%Имя%""
	|
	|	Дано Я открываю навигационную ссылку ""e1cib/list/%ПолноеИмя%""
	|	Если появилось предупреждение тогда
	|		Тогда я закрыл все окна клиентского приложения
	|		Тогда я вызываю исключение ""Не удалось открыть форму %ТипОбъекта% %Имя%""
	|	И Я закрываю текущее окно";
	
	Для каждого цТип Из СтрРазделить("Отчет,Обработка", ",") Цикл
		
		новСтрока = ШаблоныПоТипам.Добавить();
		
		новСтрока.Тип = цТип;
		новСтрока.Шаблон = "Сценарий: Открытие формы %ТипОбъекта% ""%Имя%""
		|
		|	Дано Я открываю навигационную ссылку ""e1cib/app/%ПолноеИмя%""
		|	Если появилось предупреждение тогда
		|		Тогда я закрыл все окна клиентского приложения
		|		Тогда я вызываю исключение ""Не удалось открыть форму %ТипОбъекта% %Имя%""
		|	И Я закрываю текущее окно
		|	Если появилось окно с заголовком ""Закрытие"" Тогда
		|		Тогда я нажимаю на кнопку ""Да""";
		
	КонецЦикла;
	
	ШаблоныПоТипам.Сортировать("Тип");

КонецПроцедуры

&НаСервере
Функция ШаблонСценарияОткрытьФорму(пСтрокаДерева)
	
	поискШаблона = Новый Структура("Тип", пСтрокаДерева.Тип);
	
	найденныеСтроки = ШаблоныПоТипам.НайтиСтроки(поискШаблона);
	
	Если найденныеСтроки.Количество() > 0 Тогда
		
		сценарий = найденныеСтроки[0].Шаблон;
		
	КонецЕсли;
	
	Если Не ЗначениеЗаполнено(сценарий) Тогда
		
		сценарий = "";
		
		Если пСтрокаДерева.Тип <> "Обработка" И пСтрокаДерева.Тип <> "Отчет" Тогда
			
			сценарий = сценарий + "
			|Сценарий: Открытие формы списка ""%Имя%""
			|
			|	Дано Я открываю основную форму списка %ТипОбъекта% ""%Имя%""
			|	Если появилось предупреждение тогда
			|		Тогда я вызываю исключение ""Не удалось открыть форму %ТипОбъекта% %Имя%""
			|	И Я закрываю текущее окно
			|";
			
		КонецЕсли;
		
		сценарий = сценарий + "
		|Сценарий: Открытие формы объекта ""%Имя%""
		|
		|	Дано Я открываю основную форму %ТипОбъекта% ""%Имя%""
		|	Если появилось предупреждение тогда
		|		Тогда я вызываю исключение ""Не удалось открыть форму %ТипОбъекта% %Имя%""
		|	И Я закрываю текущее окно
		|";
		
	КонецЕсли;
	
	сценарий = СтрЗаменить(сценарий, "%ПолноеИмя%", пСтрокаДерева.ПолноеИмя);
	сценарий = СтрЗаменить(сценарий, "%ТипОбъекта%", РодительныйПадеж(пСтрокаДерева.Тип));
	сценарий = СтрЗаменить(сценарий, "%Имя%", пСтрокаДерева.Имя);
	
	Возврат сценарий;
	
КонецФункции

&НаСервереБезКонтекста
Функция РодительныйПадеж(Слово)
	
	Слово = НРег(Слово);
	
	Если Слово = "справочник" Тогда
		
		Возврат "справочника";
	
	ИначеЕсли Слово = "документ" Тогда
		
		Возврат "документа";
		
	ИначеЕсли Слово = "журналдокументов" Тогда
		
		Возврат "журнала документов";
	
	ИначеЕсли Слово = "обработка" Тогда
		
		Возврат "обработки";
	
	ИначеЕсли Слово = "отчет" Тогда
		
		Возврат "отчета";
		
	ИначеЕсли Слово = "планвидовхарактеристик" Тогда
		
		Возврат "плана видов характеристик";
		
	ИначеЕсли Слово = "плансчетов" Тогда
		
		Возврат "плана счетов";
	
	ИначеЕсли Слово = "регистрнакопления" Тогда
		
		Возврат "регистра накопления";
	
	ИначеЕсли Слово = "регистрсведений" Тогда
		
		Возврат "регистра сведений";
	
	ИначеЕсли Слово = "регистрбухгалтерии" Тогда
		
		Возврат "регистра бухгалтерии";
	
	КонецЕсли;
	
КонецФункции

#КонецОбласти

#КонецОбласти

#Область Настройки

&НаСервере
Процедура ПередЗакрытиемНаСервере()
	
	ЗаполнитьВыбранныеИмена();
	
	СохранитьНастройку("ТекстИсключений", ТекстИсключений);
	СохранитьНастройку("КаталогСФичами", КаталогСФичами);
	СохранитьНастройку("ВыбранныеИмена", ВыбранныеИмена.ВыгрузитьЗначения());
	
	СохранитьНастройку("ШаблонЗаголовокФайла", ШаблонЗаголовокФайла);
	СохранитьНастройку("ШаблонПодвалФайла", ШаблонПодвалФайла);
	СохранитьНастройку("ШаблоныПоТипам", ШаблоныПоТипам.Выгрузить());
	
КонецПроцедуры

&НаКлиенте
Процедура ЗагрузитьНастройкиОбработчикОповещения(ВыбранныеФайлы, ДополнительныеПараметры) Экспорт
	
	Если ВыбранныеФайлы = Неопределено Тогда
		
		Возврат;
	
	КонецЕсли;
	
	ПолноеИмяФайла = ВыбранныеФайлы[0];
	
	ЗагрузитьНастройкиИзФайла(ПолноеИмяФайла);
	
КонецПроцедуры

&НаКлиенте
Процедура ЗагрузитьНастройкиИзФайла(Знач ПолноеИмяФайла)
	
	ЧтениеJSON = Новый ЧтениеJSON;
	ЧтениеJSON.ОткрытьФайл(ПолноеИмяФайла);
	
	Попытка
		НастройкиJSON = ПрочитатьJSON(ЧтениеJSON);
		
	Исключение
		НастройкиJSON = Неопределено;
	КонецПопытки;
	
	ЧтениеJSON.Закрыть();
	
	Если НастройкиJSON = Неопределено Тогда
		
		Возврат;
	
	КонецЕсли;
	
	Если НастройкиJSON.Свойство("Исключения") Тогда
		
		ТекстИсключений = СтрСоединить(НастройкиJSON.Исключения, Символы.ПС);
		
	КонецЕсли;
	
	Если НастройкиJSON.Свойство("КаталогСФичами") Тогда
		
		КаталогСФичами = НастройкиJSON.КаталогСФичами;
		
	КонецЕсли;
	
	Если НастройкиJSON.Свойство("ВыбранныеОбъекты") Тогда
		
		ВыбранныеИмена.ЗагрузитьЗначения(НастройкиJSON.ВыбранныеОбъекты);
		
		ЗаполнитьДеревоПоСпискуИмен();
		
	КонецЕсли;
	
	Если НастройкиJSON.Свойство("ШаблонЗаголовокФайла") Тогда
		
		ШаблонЗаголовокФайла = НастройкиJSON.ШаблонЗаголовокФайла;
		
	КонецЕсли;
	
	Если НастройкиJSON.Свойство("ШаблонПодвалФайла") Тогда
		
		ШаблонПодвалФайла = НастройкиJSON.ШаблонПодвалФайла;
		
	КонецЕсли;
	
	Если НастройкиJSON.Свойство("ШаблоныПоТипам") Тогда
		
		ШаблоныПоТипам.Очистить();
		
		Для каждого цЭлемент Из НастройкиJSON.ШаблоныПоТипам Цикл
			
			ЗаполнитьЗначенияСвойств(ШаблоныПоТипам.Добавить(), цЭлемент);
			
		КонецЦикла;
		
	КонецЕсли;
	
КонецПроцедуры

&НаКлиенте
Процедура ВыгрузитьНастройкиЗавершение(Результат, ДополнительныеПараметры) Экспорт
	
	Если Результат = Неопределено Тогда
		
		Возврат;
	
	КонецЕсли;
	
	ПолноеИмяФайла = Результат[0];
	
	НастройкиГенератора = ПодготовитьНастройкиКВыгрузке();
	
	ЗаписьТекста = Новый ЗаписьТекста(ПолноеИмяФайла, , , , Символы.ПС);
	ЗаписьТекста.Записать(НастройкиГенератора);
	ЗаписьТекста.Закрыть();
	
КонецПроцедуры

&НаКлиенте
Функция ПодготовитьНастройкиКВыгрузке()
	
	ЗаполнитьВыбранныеИмена();
	
	НастройкиСохранения = Новый Структура;
	НастройкиСохранения.Вставить("Исключения", СтрРазделить(ТекстИсключений, Символы.ПС, Ложь));
	НастройкиСохранения.Вставить("КаталогСФичами", КаталогСФичами);
	НастройкиСохранения.Вставить("ВыбранныеОбъекты", ВыбранныеИмена.ВыгрузитьЗначения());
	
	НастройкиСохранения.Вставить("ШаблонЗаголовокФайла", ШаблонЗаголовокФайла);
	НастройкиСохранения.Вставить("ШаблонПодвалФайла", ШаблонПодвалФайла);
	
	массивШаблонов = Новый Массив;
	
	Для каждого цСтрокаШаблона Из ШаблоныПоТипам Цикл
		
		структ = Новый Структура("Тип, Шаблон");
		ЗаполнитьЗначенияСвойств(структ, цСтрокаШаблона);
		
		массивШаблонов.Добавить(структ);
		
	КонецЦикла;
	
	НастройкиСохранения.Вставить("ШаблоныПоТипам", массивШаблонов);
	
	ПараметрыЗаписиJSON = Новый ПараметрыЗаписиJSON(, Символы.Таб);
	
	ЗаписьJSON = Новый ЗаписьJSON;
	ЗаписьJSON.ПроверятьСтруктуру = Ложь;
	ЗаписьJSON.УстановитьСтроку(ПараметрыЗаписиJSON);
	
	ЗаписатьJSON(ЗаписьJSON, НастройкиСохранения);
	
	Результат = ЗаписьJSON.Закрыть();
	
	Возврат Результат;
	
КонецФункции

#КонецОбласти

#Область ОбщегоНазначения

Процедура СохранитьНастройку(КлючНастроек, Настройки)
	
	ХранилищеОбщихНастроек.Сохранить(ИмяФормы, КлючНастроек(КлючНастроек), Настройки);
	
КонецПроцедуры

Функция ЗагрузитьНастройку(КлючНастроек, ЗначениеПоУмолчанию = Неопределено)
	
	Результат = Неопределено;
	
	Результат = ХранилищеОбщихНастроек.Загрузить(ИмяФормы, КлючНастроек(КлючНастроек));
	
	Если Результат = Неопределено Тогда
		
		Результат = ЗначениеПоУмолчанию;
		
	КонецЕсли;
	
	Возврат Результат;
	
КонецФункции

Функция КлючНастроек(Знач Строка)
	
	Возврат СократитьСтрокуКонтрольнойСуммой(Строка, 128);

КонецФункции

Функция СократитьСтрокуКонтрольнойСуммой(Строка, МаксимальнаяДлина) Экспорт
	
	Результат = Строка;
	
	Если СтрДлина(Строка) > МаксимальнаяДлина Тогда
		
		Результат         = Лев(Строка, МаксимальнаяДлина - 32);
		ХешированиеДанных = Новый ХешированиеДанных(ХешФункция.MD5);
		ХешированиеДанных.Добавить(Сред(Строка, МаксимальнаяДлина - 32 + 1));
		Результат = Результат + СтрЗаменить(ХешированиеДанных.ХешСумма, " ", "");
		
	КонецЕсли;
	
	Возврат Результат;
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Функция СтрокаСоответствуетШаблону(Знач ПроверяемаяСтрока, Знач Шаблон, Регулярка)
	
	Если ПроверяемаяСтрока = Шаблон Тогда
		Возврат Истина;
	КонецЕсли; 
	
	Если Регулярка = Неопределено Тогда
		Регулярка = Новый COMОбъект("VBScript.RegExp");
	КонецЕсли;
	
	Регулярка.Global = Истина;
	Регулярка.Multiline = Истина;
	// для VBScript.RegExp явно указываем что есть начало и конец строки
	Шаблон            = "^" + Шаблон + "$";
	Регулярка.Pattern = Шаблон;
	
	Возврат Регулярка.Test(ПроверяемаяСтрока);
	
КонецФункции

&НаКлиентеНаСервереБезКонтекста
Функция ПодготовитьШаблонКИспользованиюВРегулярке(Шаблон)

	// Экранируем все, кроме звездочки. Ее будем трактовать по-своему.
	СпецСимволы = Новый Массив;
	СпецСимволы.Добавить("\");
	СпецСимволы.Добавить("^");
	СпецСимволы.Добавить("$");
	СпецСимволы.Добавить("(");
	СпецСимволы.Добавить(")");
	СпецСимволы.Добавить("[");
	СпецСимволы.Добавить("]");
	СпецСимволы.Добавить("{");
	СпецСимволы.Добавить("}");
	СпецСимволы.Добавить("|");
	СпецСимволы.Добавить(".");
	СпецСимволы.Добавить("+");
	СпецСимволы.Добавить("?");
	СпецСимволы.Добавить("<");
	СпецСимволы.Добавить(">");
	
	Для Каждого СпецСимвол Из СпецСимволы Цикл
		Шаблон = СтрЗаменить(Шаблон, СпецСимвол, "\" + СпецСимвол); 
	КонецЦикла;
	
	// Трактуем * по-нашему.
	Шаблон = СтрЗаменить(Шаблон, "*", ".*");
	
	Возврат Шаблон;
	
КонецФункции

&НаКлиенте
Процедура КаталогСФичамиОткрытие(Элемент, СтандартнаяОбработка)
	
	СтандартнаяОбработка = Ложь;
	
	ОткрытьКаталогСФичами();
	
КонецПроцедуры

#КонецОбласти

#КонецОбласти
